# -*- coding: utf-8 -*-
"""
Created on Sat Jan  2 17:11:06 2021

@author: Johannes Neumeyer
"""

from graphics_and_games_klassen import Kreis, Rechteck

class LED:
    """
    Leuchte eines LED-Bandes
    """

    def __init__(self, xPos, yPos):
        """
        Leuchte wird erstellt und positioniert.
        -- Parameter xPos x-Position der LED
        -- Parameter yPos y-Position der LED
        """
        self.led = Kreis()
        self.led.PositionSetzen(xPos, yPos)
        self.led.RadiusSetzen(10)
        self.led.FarbeSetzen("weiss")

    def Einschalten(self):
        """
        Schaltet die LED in ihrer Grundfarbe gelb ein.
        """
        self.led.FarbeSetzen("gelb")

    def LichtfarbeSetzen(self, farbe):
        """
        Setzt die Lichtfarbe der LED auf die gegebene Farbe.
        -- Parameter farbe die Farbe der LED
        """
        self.led.FarbeSetzen(farbe)

class LEDBand:
    """
    LED-Band
    """

    def __init__(self):
        """
        Erzeugt das LED-Band
        """
        self.leds = []
        self.__DarstellungErzeugen()

    def Einschalten(self):
        """
        Beim Einschalten des LED-Bandes werden alle LEDs des Bandes eingeschaltet.
        """
        for l in self.leds:
            l.Einschalten()

    def MidnightMood(self):
        """
        Fuer das Beleuchtungsschema MidnightMood wird jede zweite LED
        auf die Farbe blau gesetzt.
        """
        self.Einschalten()
        self.leds[1].LichtfarbeSetzen("blau")
        self.leds[3].LichtfarbeSetzen("blau")
        self.leds[5].LichtfarbeSetzen("blau")
        self.leds[7].LichtfarbeSetzen("blau")
        self.leds[9].LichtfarbeSetzen("blau")

    def __DarstellungErzeugen(self):
        """
        Die grafische Darstellung eines LED-Bandes wird erzeugt.
        """
        band = Rechteck()
        band.GroesseSetzen(740, 19)
        band.PositionSetzen(20, 441)
        band.FarbeSetzen("grau")
        index = 0
        while index < 11:
            self.leds.append(LED(index * 70 + 40, 450))
            index = index + 1

led = LEDBand()
