# -*- coding: utf-8 -*-
"""
Created on Sat Jan  2 21:45:50 2021

@author: Johannes Neumeyer
"""

from graphics_and_games_klassen import Figur, Rechteck

class Flugzeug(Figur):
    """
    Flugzeug auf einem Rollfeld
    """

    def __init__(self, farbe):
        """
        Erstellt ein neues Flugzeug.
        -- Parameter farbe Hauptfarbe des Flugzeugs
        """
        super().__init__()
        self.DarstellungFestlegen(farbe)

    def Vorruecken(self):
        """
        Laesst ein Flugzeug auf dem Rollfeld einen Platz weiter vorruecken.
        """
        self.Gehen(100)

    def Starten(self):
        """
        Simuliert das Starten eines Flugzeugs.
        """
        self.Gehen(1000)

    def DarstellungFestlegen(self, farbe):
        """
        Legt die Darstellung eines Flugzeugs fest.
        -- Parameter farbe Hauptfarbe des Flugzeugs
        """
        self.GroesseSetzen(80)

        self.FigurteilFestlegenRechteck(-45, -25, 70, 25, farbe)
        self. FigurteilFestlegenRechteck(-50, -50, 5, 50, farbe)
        self.FigurteilFestlegenDreieck(-25, 0, -45, 0, -45, -50, farbe)
        self.FigurteilFestlegenEllipse(0, -25, 50, 25, farbe)
        self.FigurteilFestlegenDreieck(10, -15, -30, -15, -50, 10, "schwarz")
        #  Fenster vorne
        self.FigurteilFestlegenDreieck(30, -25, 30, -10, 50, -10, "schwarz")
        #  Raeder vorne
        self.FigurteilFestlegenRechteck(25, 0, 1, 5, "schwarz")
        self.FigurteilFestlegenEllipse(22, 8, 7, 7, "schwarz")
        #  Raeder hinten
        self.FigurteilFestlegenRechteck(-20, 0, 1, 5, "schwarz")
        self.FigurteilFestlegenEllipse(-24, 6, 9, 9, "schwarz")

class Rollfeld:
    """
    Rollfeld an einem Flughafen
    """

    def __init__(self):
        """
        Erstellt ein Rollfeld eines Flughafens
        """
        self.flugzeuge = []
        self.RollfeldErstellen()
        # Aufrufe zum Testen
        # self.InWarteschlangeEinreihen(Flugzeug("rot"))
        # self.InWarteschlangeEinreihen(Flugzeug("gelb"))
        # self.InWarteschlangeEinreihen(Flugzeug("gruen"))
        # self.InWarteschlangeEinreihen(Flugzeug("magenta"))
        # self.InWarteschlangeEinreihen(Flugzeug("cyan"))
        # self.InWarteschlangeEinreihen(Flugzeug("grau"))

    def RollfeldErstellen(self):
        """
        Erstellt das Rollfeld.
        """
        rollfeld = Rechteck()
        rollfeld.GroesseSetzen(1000, 500)
        rollfeld.PositionSetzen(0, 413)
        rollfeld.FarbeSetzen("grau")
        startpiste = Rechteck()
        startpiste.GroesseSetzen(400, 5)
        startpiste.PositionSetzen(600, 413)
        startpiste.FarbeSetzen("orange")

r = Rollfeld()
